package com.objis.demojsferror;

import java.text.MessageFormat;
import java.util.Locale;
import java.util.ResourceBundle;

import javax.faces.application.FacesMessage;
import javax.faces.bean.ManagedBean;
import javax.faces.context.FacesContext;

import com.objis.demojsferror.exceptions.ApplicationModuleError;
import com.objis.demojsferror.exceptions.I18nException;

@ManagedBean
public class MonBean {
	
	private int age;

    public int getAge() {
		return age;
	}

	public void setAge(int age) {
		this.age = age;
	}

    public String submit(){
        try{
            if (true) throw new ApplicationModuleError("Rien soumi !");
        } catch (Throwable t){
            handleException(t);
        }
        return null;
    }
    
    public void handleException(Throwable exception) {
        String message = "";
        if (exception instanceof I18nException) {
            I18nException i18nException = (I18nException) exception;
            Locale locale = FacesContext.getCurrentInstance().getViewRoot().getLocale();            
            String pattern = getResourceBundle(locale).getString(i18nException.getBundleKey());
            message = MessageFormat.format(pattern, i18nException.getArguments());
        } else
            message = "An unexpected error occured !";
        FacesMessage facesMessage = new FacesMessage(message);
        FacesContext.getCurrentInstance().addMessage(null, facesMessage);
    }


    
    private ResourceBundle getResourceBundle(Locale locale){
        FacesContext context = FacesContext.getCurrentInstance(); 
        return ResourceBundle.getBundle(context.getApplication().getMessageBundle(),locale); 
    }

	class ApplicationError extends RuntimeException{

		private static final long serialVersionUID = 1L;

		private ApplicationError(String message) {super(message);}
    };
    
}



